Imports Tao.Platform.Windows
Imports System.Math
Imports System.Drawing

Public Structure RGB
    Dim R As Single            ' background color
    Dim G As Single            ' background color
    Dim B As Single            ' background color
End Structure

Public Structure Coordinate
    Dim x As Double            ' background color
    Dim y As Double            ' background color
    Dim z As Double            ' background color

    Public Sub New(ByVal x As Double, ByVal y As Double, ByVal z As Double)
        Me.x = x
        Me.y = y
        Me.z = z
    End Sub
End Structure

Public Class frmMain
    Inherits System.Windows.Forms.Form
    Dim RPMs As Single                  ' increment size for the rotation speed
    Public Shared arrPoints(0, 0) As Single       ' array to hold all points to plot
    Public Shared arrAdjPoints(0, 0) As Single    ' array to hold points after manipulation
    Public Shared arrCells()() As Double          ' array to hold vertex index for all polygons to be drawn
    Public Shared arrIntensity(0) As Single       ' array to hold intensity values for color coding
    Public Shared arrAdjIntensity(0) As Single    ' array to hold the normailzed intensity values for plotting
    Dim intensityMaxMin(1) As Single    ' Maximum and minimum intensity values
    Dim arrNormals(0, 2) As Single      ' array to hold normal vectors to all polygons
    Dim arrAdjNormals(0, 2) As Single   ' array to hold normal vectors after manipulation
    Dim Zoom As Single                  ' current zoom factor in distance units
    Dim refZoom As Single               ' predetermined zoom factor based on bounding sphere dimensions
    Dim RotUp As Single                 ' Vertical rotation rate in rpm
    Dim RotRight As Single              ' Horizontal rotation rate in rpm
    Dim XShift As Single                ' Horizontal displacement for the object
    Dim YShift As Single                ' Vertical displacement for the object
    Dim strFileName As String           ' filename for the source data
    Dim ReInit As Boolean               ' signal to reinitialize OpenGL
    Dim Plot_Grid As Boolean            ' enables or disables gridlines
    Dim Plot_Model As Boolean           ' enables or disables plotting the model
    Dim Light_Param As Single           ' light intensity parameter
    Dim BkgColor As RGB                 ' background color
    Dim HotSpots() As Single            ' list of hot spot node numbers
    Dim ColorMode As Integer            ' set to 1 to plot minimums in red, 0 to plot maximums in red
    Dim HotSpotMin As Single            ' Hard floor for Hot Spot Finder (in %)
    Dim HotSpotSensitivity As Single    ' minimum % increase to be considered the end of a hot spot
    Dim HotSpotParameters(,) As Single  ' hold values for the hot spot intensities in each plot type
    Dim HotSpotRadius As Single         ' hold the ratio of hot spot radius to bounding shpere radius
    Dim arrModes() As String            ' holds values for the plot modes found in the source file
    Dim SelectedHotSpot As Single       ' holds the node number of the selected hotpot
    Dim hDC As System.IntPtr

#Region "Friends "
    Friend WithEvents lblZoom As System.Windows.Forms.Label
    Friend WithEvents HelpToolStripMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents VisitUsOnTheWebToolStripMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents mnuAbout As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents cmdRotUp As System.Windows.Forms.Button
    Friend WithEvents lblRotate As System.Windows.Forms.Label
    Friend WithEvents cmdRotDown As System.Windows.Forms.Button
    Friend WithEvents cmdRotRight As System.Windows.Forms.Button
    Friend WithEvents cmdRotLeft As System.Windows.Forms.Button
    Friend WithEvents cmdRotStop As System.Windows.Forms.Button
    Friend WithEvents cmdMovCenter As System.Windows.Forms.Button
    Friend WithEvents cmdMovLeft As System.Windows.Forms.Button
    Friend WithEvents cmdMovRight As System.Windows.Forms.Button
    Friend WithEvents cmdMovDown As System.Windows.Forms.Button
    Friend WithEvents cmdMovUp As System.Windows.Forms.Button
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents cmdResetRotation As System.Windows.Forms.Button
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents cmbPlotType As System.Windows.Forms.ComboBox
    Friend WithEvents ctrlTabs As System.Windows.Forms.TabControl
    Friend WithEvents TabPage1 As System.Windows.Forms.TabPage
    Friend WithEvents TabPage2 As System.Windows.Forms.TabPage
    Friend WithEvents pnlLegend As System.Windows.Forms.Panel
    Friend WithEvents picLegend As System.Windows.Forms.PictureBox
    Friend WithEvents txtLegendMax As System.Windows.Forms.TextBox
    Friend WithEvents txtLegendMin As System.Windows.Forms.TextBox
    Friend WithEvents mnuSaveAs As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents Sav As System.Windows.Forms.GroupBox
    Friend WithEvents AnimateWorker As System.ComponentModel.BackgroundWorker
    Friend WithEvents ToolsToolStripMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents mnuOptions As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip
    Friend WithEvents cmbCriticalPoints As System.Windows.Forms.ComboBox
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents cmdViewChange As System.Windows.Forms.Button
    Friend WithEvents cmdRefreshHotSpot As System.Windows.Forms.Button
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents ProgressBar As System.Windows.Forms.ToolStripProgressBar
    Friend WithEvents LoadWorker As System.ComponentModel.BackgroundWorker
    Friend WithEvents HotSpotWorker As System.ComponentModel.BackgroundWorker
    Friend WithEvents radMin As System.Windows.Forms.RadioButton
    Friend WithEvents radMax As System.Windows.Forms.RadioButton
    Friend WithEvents mnuLoadSample As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents cmdClear As System.Windows.Forms.Button
    Friend WithEvents DataGridView As System.Windows.Forms.DataGridView
    Friend WithEvents DataName As System.Windows.Forms.DataGridViewTextBoxColumn
    Friend WithEvents DataValue As System.Windows.Forms.DataGridViewTextBoxColumn
    Friend WithEvents txtZoom As System.Windows.Forms.TextBox
#End Region

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()


    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Friend WithEvents StatusBar As System.Windows.Forms.StatusStrip
    Friend WithEvents StatusLabel As System.Windows.Forms.ToolStripStatusLabel
    Friend WithEvents MenuStrip As System.Windows.Forms.MenuStrip
    Friend WithEvents FileToolStripMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents mnuOpen As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents mnuExit As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents PictureBox As System.Windows.Forms.PictureBox

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(frmMain))
        Me.Label2 = New System.Windows.Forms.Label
        Me.cmbPlotType = New System.Windows.Forms.ComboBox
        Me.Label1 = New System.Windows.Forms.Label
        Me.lblRotate = New System.Windows.Forms.Label
        Me.lblZoom = New System.Windows.Forms.Label
        Me.txtZoom = New System.Windows.Forms.TextBox
        Me.StatusBar = New System.Windows.Forms.StatusStrip
        Me.ProgressBar = New System.Windows.Forms.ToolStripProgressBar
        Me.StatusLabel = New System.Windows.Forms.ToolStripStatusLabel
        Me.MenuStrip = New System.Windows.Forms.MenuStrip
        Me.FileToolStripMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.mnuOpen = New System.Windows.Forms.ToolStripMenuItem
        Me.mnuSaveAs = New System.Windows.Forms.ToolStripMenuItem
        Me.mnuExit = New System.Windows.Forms.ToolStripMenuItem
        Me.ToolsToolStripMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.mnuOptions = New System.Windows.Forms.ToolStripMenuItem
        Me.HelpToolStripMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.VisitUsOnTheWebToolStripMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.mnuAbout = New System.Windows.Forms.ToolStripMenuItem
        Me.mnuLoadSample = New System.Windows.Forms.ToolStripMenuItem
        Me.ctrlTabs = New System.Windows.Forms.TabControl
        Me.TabPage1 = New System.Windows.Forms.TabPage
        Me.Label4 = New System.Windows.Forms.Label
        Me.pnlLegend = New System.Windows.Forms.Panel
        Me.radMin = New System.Windows.Forms.RadioButton
        Me.radMax = New System.Windows.Forms.RadioButton
        Me.Label5 = New System.Windows.Forms.Label
        Me.txtLegendMax = New System.Windows.Forms.TextBox
        Me.txtLegendMin = New System.Windows.Forms.TextBox
        Me.picLegend = New System.Windows.Forms.PictureBox
        Me.cmdRotUp = New System.Windows.Forms.Button
        Me.cmdResetRotation = New System.Windows.Forms.Button
        Me.cmdMovCenter = New System.Windows.Forms.Button
        Me.cmdRotDown = New System.Windows.Forms.Button
        Me.cmdMovLeft = New System.Windows.Forms.Button
        Me.cmdRotRight = New System.Windows.Forms.Button
        Me.cmdMovRight = New System.Windows.Forms.Button
        Me.cmdRotLeft = New System.Windows.Forms.Button
        Me.cmdMovDown = New System.Windows.Forms.Button
        Me.cmdRotStop = New System.Windows.Forms.Button
        Me.cmdMovUp = New System.Windows.Forms.Button
        Me.TabPage2 = New System.Windows.Forms.TabPage
        Me.cmdClear = New System.Windows.Forms.Button
        Me.cmdRefreshHotSpot = New System.Windows.Forms.Button
        Me.cmdViewChange = New System.Windows.Forms.Button
        Me.Label3 = New System.Windows.Forms.Label
        Me.cmbCriticalPoints = New System.Windows.Forms.ComboBox
        Me.Sav = New System.Windows.Forms.GroupBox
        Me.PictureBox = New System.Windows.Forms.PictureBox
        Me.AnimateWorker = New System.ComponentModel.BackgroundWorker
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.LoadWorker = New System.ComponentModel.BackgroundWorker
        Me.HotSpotWorker = New System.ComponentModel.BackgroundWorker
        Me.DataGridView = New System.Windows.Forms.DataGridView
        Me.DataName = New System.Windows.Forms.DataGridViewTextBoxColumn
        Me.DataValue = New System.Windows.Forms.DataGridViewTextBoxColumn
        Me.StatusBar.SuspendLayout()
        Me.MenuStrip.SuspendLayout()
        Me.ctrlTabs.SuspendLayout()
        Me.TabPage1.SuspendLayout()
        Me.pnlLegend.SuspendLayout()
        CType(Me.picLegend, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.TabPage2.SuspendLayout()
        CType(Me.PictureBox, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.DataGridView, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label2
        '
        Me.Label2.AutoSize = True
        Me.Label2.Location = New System.Drawing.Point(6, 391)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(52, 13)
        Me.Label2.TabIndex = 16
        Me.Label2.Text = "Plot Type"
        '
        'cmbPlotType
        '
        Me.cmbPlotType.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbPlotType.FormattingEnabled = True
        Me.cmbPlotType.Location = New System.Drawing.Point(6, 407)
        Me.cmbPlotType.Name = "cmbPlotType"
        Me.cmbPlotType.Size = New System.Drawing.Size(70, 21)
        Me.cmbPlotType.TabIndex = 15
        Me.ToolTip1.SetToolTip(Me.cmbPlotType, "Select a Dataset")
        '
        'Label1
        '
        Me.Label1.AutoSize = True
        Me.Label1.Location = New System.Drawing.Point(43, 368)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(15, 13)
        Me.Label1.TabIndex = 13
        Me.Label1.Text = "%"
        '
        'lblRotate
        '
        Me.lblRotate.AutoSize = True
        Me.lblRotate.Location = New System.Drawing.Point(6, 3)
        Me.lblRotate.Name = "lblRotate"
        Me.lblRotate.Size = New System.Drawing.Size(39, 13)
        Me.lblRotate.TabIndex = 2
        Me.lblRotate.Text = "Rotate"
        '
        'lblZoom
        '
        Me.lblZoom.AutoSize = True
        Me.lblZoom.Location = New System.Drawing.Point(6, 349)
        Me.lblZoom.Name = "lblZoom"
        Me.lblZoom.Size = New System.Drawing.Size(34, 13)
        Me.lblZoom.TabIndex = 1
        Me.lblZoom.Text = "Zoom"
        '
        'txtZoom
        '
        Me.txtZoom.Location = New System.Drawing.Point(6, 365)
        Me.txtZoom.Name = "txtZoom"
        Me.txtZoom.Size = New System.Drawing.Size(39, 20)
        Me.txtZoom.TabIndex = 0
        Me.txtZoom.Text = "100"
        Me.txtZoom.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.ToolTip1.SetToolTip(Me.txtZoom, "Enter Zoom Factor")
        '
        'StatusBar
        '
        Me.StatusBar.Items.AddRange(New System.Windows.Forms.ToolStripItem() {Me.ProgressBar, Me.StatusLabel})
        Me.StatusBar.Location = New System.Drawing.Point(0, 716)
        Me.StatusBar.Name = "StatusBar"
        Me.StatusBar.Size = New System.Drawing.Size(784, 22)
        Me.StatusBar.TabIndex = 4
        Me.StatusBar.Text = "No file loaded."
        '
        'ProgressBar
        '
        Me.ProgressBar.Maximum = 1001
        Me.ProgressBar.Name = "ProgressBar"
        Me.ProgressBar.Size = New System.Drawing.Size(100, 16)
        Me.ProgressBar.Step = 1
        Me.ProgressBar.Style = System.Windows.Forms.ProgressBarStyle.Continuous
        '
        'StatusLabel
        '
        Me.StatusLabel.Name = "StatusLabel"
        Me.StatusLabel.Size = New System.Drawing.Size(123, 17)
        Me.StatusLabel.Text = "No Model File Loaded"
        '
        'MenuStrip
        '
        Me.MenuStrip.Items.AddRange(New System.Windows.Forms.ToolStripItem() {Me.FileToolStripMenuItem, Me.ToolsToolStripMenuItem, Me.HelpToolStripMenuItem})
        Me.MenuStrip.Location = New System.Drawing.Point(0, 0)
        Me.MenuStrip.Name = "MenuStrip"
        Me.MenuStrip.Size = New System.Drawing.Size(784, 24)
        Me.MenuStrip.TabIndex = 5
        Me.MenuStrip.Text = "MenuStrip1"
        '
        'FileToolStripMenuItem
        '
        Me.FileToolStripMenuItem.DropDownItems.AddRange(New System.Windows.Forms.ToolStripItem() {Me.mnuOpen, Me.mnuSaveAs, Me.mnuExit})
        Me.FileToolStripMenuItem.Name = "FileToolStripMenuItem"
        Me.FileToolStripMenuItem.Size = New System.Drawing.Size(37, 20)
        Me.FileToolStripMenuItem.Text = "&File"
        '
        'mnuOpen
        '
        Me.mnuOpen.Name = "mnuOpen"
        Me.mnuOpen.Size = New System.Drawing.Size(114, 22)
        Me.mnuOpen.Text = "&Open"
        '
        'mnuSaveAs
        '
        Me.mnuSaveAs.Enabled = False
        Me.mnuSaveAs.Name = "mnuSaveAs"
        Me.mnuSaveAs.Size = New System.Drawing.Size(114, 22)
        Me.mnuSaveAs.Text = "S&ave As"
        '
        'mnuExit
        '
        Me.mnuExit.Name = "mnuExit"
        Me.mnuExit.Size = New System.Drawing.Size(114, 22)
        Me.mnuExit.Text = "E&xit"
        '
        'ToolsToolStripMenuItem
        '
        Me.ToolsToolStripMenuItem.DropDownItems.AddRange(New System.Windows.Forms.ToolStripItem() {Me.mnuOptions})
        Me.ToolsToolStripMenuItem.Name = "ToolsToolStripMenuItem"
        Me.ToolsToolStripMenuItem.Size = New System.Drawing.Size(48, 20)
        Me.ToolsToolStripMenuItem.Text = "&Tools"
        '
        'mnuOptions
        '
        Me.mnuOptions.Name = "mnuOptions"
        Me.mnuOptions.Size = New System.Drawing.Size(116, 22)
        Me.mnuOptions.Text = "&Options"
        '
        'HelpToolStripMenuItem
        '
        Me.HelpToolStripMenuItem.DropDownItems.AddRange(New System.Windows.Forms.ToolStripItem() {Me.VisitUsOnTheWebToolStripMenuItem, Me.mnuAbout, Me.mnuLoadSample})
        Me.HelpToolStripMenuItem.Name = "HelpToolStripMenuItem"
        Me.HelpToolStripMenuItem.Size = New System.Drawing.Size(44, 20)
        Me.HelpToolStripMenuItem.Text = "&Help"
        '
        'VisitUsOnTheWebToolStripMenuItem
        '
        Me.VisitUsOnTheWebToolStripMenuItem.Name = "VisitUsOnTheWebToolStripMenuItem"
        Me.VisitUsOnTheWebToolStripMenuItem.Size = New System.Drawing.Size(179, 22)
        Me.VisitUsOnTheWebToolStripMenuItem.Text = "&Visit Us on the Web"
        '
        'mnuAbout
        '
        Me.mnuAbout.Name = "mnuAbout"
        Me.mnuAbout.Size = New System.Drawing.Size(179, 22)
        Me.mnuAbout.Text = "&About"
        '
        'mnuLoadSample
        '
        Me.mnuLoadSample.Name = "mnuLoadSample"
        Me.mnuLoadSample.Size = New System.Drawing.Size(179, 22)
        Me.mnuLoadSample.Text = "&Load Sample Model"
        '
        'ctrlTabs
        '
        Me.ctrlTabs.Alignment = System.Windows.Forms.TabAlignment.Right
        Me.ctrlTabs.Controls.Add(Me.TabPage1)
        Me.ctrlTabs.Controls.Add(Me.TabPage2)
        Me.ctrlTabs.Dock = System.Windows.Forms.DockStyle.Right
        Me.ctrlTabs.Location = New System.Drawing.Point(673, 24)
        Me.ctrlTabs.Multiline = True
        Me.ctrlTabs.Name = "ctrlTabs"
        Me.ctrlTabs.SelectedIndex = 0
        Me.ctrlTabs.Size = New System.Drawing.Size(111, 692)
        Me.ctrlTabs.TabIndex = 6
        '
        'TabPage1
        '
        Me.TabPage1.BackColor = System.Drawing.Color.Transparent
        Me.TabPage1.Controls.Add(Me.Label4)
        Me.TabPage1.Controls.Add(Me.pnlLegend)
        Me.TabPage1.Controls.Add(Me.Label1)
        Me.TabPage1.Controls.Add(Me.Label2)
        Me.TabPage1.Controls.Add(Me.lblRotate)
        Me.TabPage1.Controls.Add(Me.cmbPlotType)
        Me.TabPage1.Controls.Add(Me.cmdRotUp)
        Me.TabPage1.Controls.Add(Me.cmdResetRotation)
        Me.TabPage1.Controls.Add(Me.cmdMovCenter)
        Me.TabPage1.Controls.Add(Me.cmdRotDown)
        Me.TabPage1.Controls.Add(Me.cmdMovLeft)
        Me.TabPage1.Controls.Add(Me.cmdRotRight)
        Me.TabPage1.Controls.Add(Me.cmdMovRight)
        Me.TabPage1.Controls.Add(Me.cmdRotLeft)
        Me.TabPage1.Controls.Add(Me.cmdMovDown)
        Me.TabPage1.Controls.Add(Me.cmdRotStop)
        Me.TabPage1.Controls.Add(Me.cmdMovUp)
        Me.TabPage1.Controls.Add(Me.lblZoom)
        Me.TabPage1.Controls.Add(Me.txtZoom)
        Me.TabPage1.Location = New System.Drawing.Point(4, 4)
        Me.TabPage1.Name = "TabPage1"
        Me.TabPage1.Padding = New System.Windows.Forms.Padding(3)
        Me.TabPage1.Size = New System.Drawing.Size(84, 684)
        Me.TabPage1.TabIndex = 0
        Me.TabPage1.Text = "Controls"
        '
        'Label4
        '
        Me.Label4.AutoSize = True
        Me.Label4.Location = New System.Drawing.Point(6, 176)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(28, 13)
        Me.Label4.TabIndex = 17
        Me.Label4.Text = "Shift"
        '
        'pnlLegend
        '
        Me.pnlLegend.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.pnlLegend.AutoSize = True
        Me.pnlLegend.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink
        Me.pnlLegend.BackColor = System.Drawing.Color.Gainsboro
        Me.pnlLegend.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.pnlLegend.Controls.Add(Me.radMin)
        Me.pnlLegend.Controls.Add(Me.radMax)
        Me.pnlLegend.Controls.Add(Me.Label5)
        Me.pnlLegend.Controls.Add(Me.txtLegendMax)
        Me.pnlLegend.Controls.Add(Me.txtLegendMin)
        Me.pnlLegend.Controls.Add(Me.picLegend)
        Me.pnlLegend.Location = New System.Drawing.Point(6, 472)
        Me.pnlLegend.Name = "pnlLegend"
        Me.pnlLegend.Size = New System.Drawing.Size(79, 209)
        Me.pnlLegend.TabIndex = 7
        Me.pnlLegend.Visible = False
        '
        'radMin
        '
        Me.radMin.AutoSize = True
        Me.radMin.Location = New System.Drawing.Point(29, 35)
        Me.radMin.Name = "radMin"
        Me.radMin.Size = New System.Drawing.Size(42, 17)
        Me.radMin.TabIndex = 18
        Me.radMin.Text = "Min"
        Me.ToolTip1.SetToolTip(Me.radMin, "Plot Minimum in Red")
        Me.radMin.UseVisualStyleBackColor = True
        '
        'radMax
        '
        Me.radMax.AutoSize = True
        Me.radMax.Checked = True
        Me.radMax.Location = New System.Drawing.Point(29, 53)
        Me.radMax.Name = "radMax"
        Me.radMax.Size = New System.Drawing.Size(45, 17)
        Me.radMax.TabIndex = 19
        Me.radMax.TabStop = True
        Me.radMax.Text = "Max"
        Me.ToolTip1.SetToolTip(Me.radMax, "Plot Maximum in Red")
        Me.radMax.UseVisualStyleBackColor = True
        '
        'Label5
        '
        Me.Label5.AutoSize = True
        Me.Label5.Location = New System.Drawing.Point(0, 0)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(43, 13)
        Me.Label5.TabIndex = 5
        Me.Label5.Text = "Legend"
        '
        'txtLegendMax
        '
        Me.txtLegendMax.Location = New System.Drawing.Point(28, 184)
        Me.txtLegendMax.Name = "txtLegendMax"
        Me.txtLegendMax.Size = New System.Drawing.Size(40, 20)
        Me.txtLegendMax.TabIndex = 4
        Me.txtLegendMax.Text = "Max"
        '
        'txtLegendMin
        '
        Me.txtLegendMin.Location = New System.Drawing.Point(28, 16)
        Me.txtLegendMin.Name = "txtLegendMin"
        Me.txtLegendMin.Size = New System.Drawing.Size(40, 20)
        Me.txtLegendMin.TabIndex = 3
        Me.txtLegendMin.Text = "Min"
        '
        'picLegend
        '
        Me.picLegend.Image = Global.My.Resources.Resources.Legend_1
        Me.picLegend.Location = New System.Drawing.Point(3, 16)
        Me.picLegend.Name = "picLegend"
        Me.picLegend.Size = New System.Drawing.Size(24, 188)
        Me.picLegend.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage
        Me.picLegend.TabIndex = 0
        Me.picLegend.TabStop = False
        '
        'cmdRotUp
        '
        Me.cmdRotUp.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch
        Me.cmdRotUp.Image = Global.My.Resources.Resources.gds_rotate_up
        Me.cmdRotUp.Location = New System.Drawing.Point(24, 19)
        Me.cmdRotUp.Name = "cmdRotUp"
        Me.cmdRotUp.Size = New System.Drawing.Size(34, 34)
        Me.cmdRotUp.TabIndex = 3
        Me.ToolTip1.SetToolTip(Me.cmdRotUp, "Increase Vertical Rotation Speed")
        Me.cmdRotUp.UseVisualStyleBackColor = True
        '
        'cmdResetRotation
        '
        Me.cmdResetRotation.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch
        Me.cmdResetRotation.Image = CType(resources.GetObject("cmdResetRotation.Image"), System.Drawing.Image)
        Me.cmdResetRotation.Location = New System.Drawing.Point(43, 139)
        Me.cmdResetRotation.Name = "cmdResetRotation"
        Me.cmdResetRotation.Size = New System.Drawing.Size(34, 34)
        Me.cmdResetRotation.TabIndex = 14
        Me.ToolTip1.SetToolTip(Me.cmdResetRotation, "Reset Rotation")
        Me.cmdResetRotation.UseVisualStyleBackColor = True
        '
        'cmdMovCenter
        '
        Me.cmdMovCenter.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch
        Me.cmdMovCenter.Image = Global.My.Resources.Resources.Central1
        Me.cmdMovCenter.Location = New System.Drawing.Point(24, 312)
        Me.cmdMovCenter.Name = "cmdMovCenter"
        Me.cmdMovCenter.Size = New System.Drawing.Size(34, 34)
        Me.cmdMovCenter.TabIndex = 12
        Me.ToolTip1.SetToolTip(Me.cmdMovCenter, "Center Model")
        Me.cmdMovCenter.UseVisualStyleBackColor = True
        '
        'cmdRotDown
        '
        Me.cmdRotDown.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch
        Me.cmdRotDown.Image = Global.My.Resources.Resources.gds_rotate_down
        Me.cmdRotDown.Location = New System.Drawing.Point(24, 99)
        Me.cmdRotDown.Name = "cmdRotDown"
        Me.cmdRotDown.Size = New System.Drawing.Size(34, 34)
        Me.cmdRotDown.TabIndex = 4
        Me.ToolTip1.SetToolTip(Me.cmdRotDown, "Decrease Vertical Rotation Speed")
        Me.cmdRotDown.UseVisualStyleBackColor = True
        '
        'cmdMovLeft
        '
        Me.cmdMovLeft.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch
        Me.cmdMovLeft.Image = Global.My.Resources.Resources.arrow_left
        Me.cmdMovLeft.Location = New System.Drawing.Point(6, 232)
        Me.cmdMovLeft.Name = "cmdMovLeft"
        Me.cmdMovLeft.Size = New System.Drawing.Size(34, 34)
        Me.cmdMovLeft.TabIndex = 11
        Me.ToolTip1.SetToolTip(Me.cmdMovLeft, "Shift Model Left")
        Me.cmdMovLeft.UseVisualStyleBackColor = True
        '
        'cmdRotRight
        '
        Me.cmdRotRight.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch
        Me.cmdRotRight.Image = Global.My.Resources.Resources.gds_rotate_right
        Me.cmdRotRight.Location = New System.Drawing.Point(43, 59)
        Me.cmdRotRight.Name = "cmdRotRight"
        Me.cmdRotRight.Size = New System.Drawing.Size(34, 34)
        Me.cmdRotRight.TabIndex = 5
        Me.ToolTip1.SetToolTip(Me.cmdRotRight, "Increase Horizontal Rotation Speed")
        Me.cmdRotRight.UseVisualStyleBackColor = True
        '
        'cmdMovRight
        '
        Me.cmdMovRight.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch
        Me.cmdMovRight.Image = Global.My.Resources.Resources.arrow_right
        Me.cmdMovRight.Location = New System.Drawing.Point(43, 232)
        Me.cmdMovRight.Name = "cmdMovRight"
        Me.cmdMovRight.Size = New System.Drawing.Size(34, 34)
        Me.cmdMovRight.TabIndex = 10
        Me.ToolTip1.SetToolTip(Me.cmdMovRight, "Shift Model Right")
        Me.cmdMovRight.UseVisualStyleBackColor = True
        '
        'cmdRotLeft
        '
        Me.cmdRotLeft.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch
        Me.cmdRotLeft.Image = Global.My.Resources.Resources.gds_rotate_left
        Me.cmdRotLeft.Location = New System.Drawing.Point(6, 59)
        Me.cmdRotLeft.Name = "cmdRotLeft"
        Me.cmdRotLeft.Size = New System.Drawing.Size(34, 34)
        Me.cmdRotLeft.TabIndex = 6
        Me.ToolTip1.SetToolTip(Me.cmdRotLeft, "Decrease Horizontal Rotation Speed")
        Me.cmdRotLeft.UseVisualStyleBackColor = True
        '
        'cmdMovDown
        '
        Me.cmdMovDown.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch
        Me.cmdMovDown.Image = Global.My.Resources.Resources.arrow_down
        Me.cmdMovDown.Location = New System.Drawing.Point(24, 272)
        Me.cmdMovDown.Name = "cmdMovDown"
        Me.cmdMovDown.Size = New System.Drawing.Size(34, 34)
        Me.cmdMovDown.TabIndex = 9
        Me.ToolTip1.SetToolTip(Me.cmdMovDown, "Shift Model Down")
        Me.cmdMovDown.UseVisualStyleBackColor = True
        '
        'cmdRotStop
        '
        Me.cmdRotStop.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch
        Me.cmdRotStop.Image = Global.My.Resources.Resources.stop_sign
        Me.cmdRotStop.Location = New System.Drawing.Point(6, 139)
        Me.cmdRotStop.Name = "cmdRotStop"
        Me.cmdRotStop.Size = New System.Drawing.Size(34, 34)
        Me.cmdRotStop.TabIndex = 7
        Me.ToolTip1.SetToolTip(Me.cmdRotStop, "Stop Rotation")
        Me.cmdRotStop.UseVisualStyleBackColor = True
        '
        'cmdMovUp
        '
        Me.cmdMovUp.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch
        Me.cmdMovUp.Image = Global.My.Resources.Resources.arrow_up
        Me.cmdMovUp.Location = New System.Drawing.Point(24, 192)
        Me.cmdMovUp.Name = "cmdMovUp"
        Me.cmdMovUp.Size = New System.Drawing.Size(34, 34)
        Me.cmdMovUp.TabIndex = 8
        Me.ToolTip1.SetToolTip(Me.cmdMovUp, "Shift Model Up")
        Me.cmdMovUp.UseVisualStyleBackColor = True
        '
        'TabPage2
        '
        Me.TabPage2.BackColor = System.Drawing.SystemColors.Control
        Me.TabPage2.Controls.Add(Me.cmdClear)
        Me.TabPage2.Controls.Add(Me.cmdRefreshHotSpot)
        Me.TabPage2.Controls.Add(Me.cmdViewChange)
        Me.TabPage2.Controls.Add(Me.Label3)
        Me.TabPage2.Controls.Add(Me.cmbCriticalPoints)
        Me.TabPage2.Location = New System.Drawing.Point(4, 4)
        Me.TabPage2.Name = "TabPage2"
        Me.TabPage2.Padding = New System.Windows.Forms.Padding(3)
        Me.TabPage2.Size = New System.Drawing.Size(84, 684)
        Me.TabPage2.TabIndex = 1
        Me.TabPage2.Text = "Critical Points"
        '
        'cmdClear
        '
        Me.cmdClear.Enabled = False
        Me.cmdClear.Location = New System.Drawing.Point(4, 120)
        Me.cmdClear.Name = "cmdClear"
        Me.cmdClear.Size = New System.Drawing.Size(71, 24)
        Me.cmdClear.TabIndex = 4
        Me.cmdClear.Text = "Clear"
        Me.ToolTip1.SetToolTip(Me.cmdClear, "Go to Selected Hot Spot")
        Me.cmdClear.UseVisualStyleBackColor = True
        '
        'cmdRefreshHotSpot
        '
        Me.cmdRefreshHotSpot.Cursor = System.Windows.Forms.Cursors.Default
        Me.cmdRefreshHotSpot.Enabled = False
        Me.cmdRefreshHotSpot.Location = New System.Drawing.Point(4, 3)
        Me.cmdRefreshHotSpot.Name = "cmdRefreshHotSpot"
        Me.cmdRefreshHotSpot.Size = New System.Drawing.Size(71, 24)
        Me.cmdRefreshHotSpot.TabIndex = 3
        Me.cmdRefreshHotSpot.Text = "Analyze"
        Me.ToolTip1.SetToolTip(Me.cmdRefreshHotSpot, "Analyze Hot Spots")
        Me.cmdRefreshHotSpot.UseVisualStyleBackColor = True
        '
        'cmdViewChange
        '
        Me.cmdViewChange.Enabled = False
        Me.cmdViewChange.Location = New System.Drawing.Point(4, 90)
        Me.cmdViewChange.Name = "cmdViewChange"
        Me.cmdViewChange.Size = New System.Drawing.Size(71, 24)
        Me.cmdViewChange.TabIndex = 2
        Me.cmdViewChange.Text = "Go"
        Me.ToolTip1.SetToolTip(Me.cmdViewChange, "Go to Selected Hot Spot")
        Me.cmdViewChange.UseVisualStyleBackColor = True
        '
        'Label3
        '
        Me.Label3.AutoSize = True
        Me.Label3.Location = New System.Drawing.Point(-3, 47)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(82, 13)
        Me.Label3.TabIndex = 1
        Me.Label3.Text = "Select Hot Spot"
        '
        'cmbCriticalPoints
        '
        Me.cmbCriticalPoints.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbCriticalPoints.Enabled = False
        Me.cmbCriticalPoints.FormattingEnabled = True
        Me.cmbCriticalPoints.Items.AddRange(New Object() {"Minimum"})
        Me.cmbCriticalPoints.Location = New System.Drawing.Point(0, 63)
        Me.cmbCriticalPoints.Name = "cmbCriticalPoints"
        Me.cmbCriticalPoints.Size = New System.Drawing.Size(83, 21)
        Me.cmbCriticalPoints.TabIndex = 0
        '
        'Sav
        '
        Me.Sav.Location = New System.Drawing.Point(226, 142)
        Me.Sav.Name = "Sav"
        Me.Sav.Size = New System.Drawing.Size(179, 98)
        Me.Sav.TabIndex = 8
        Me.Sav.TabStop = False
        Me.Sav.Text = "Saving..."
        '
        'PictureBox
        '
        Me.PictureBox.BackColor = System.Drawing.SystemColors.ControlDarkDark
        Me.PictureBox.Location = New System.Drawing.Point(0, 27)
        Me.PictureBox.Name = "PictureBox"
        Me.PictureBox.Size = New System.Drawing.Size(675, 662)
        Me.PictureBox.TabIndex = 0
        Me.PictureBox.TabStop = False
        '
        'AnimateWorker
        '
        Me.AnimateWorker.WorkerSupportsCancellation = True
        '
        'LoadWorker
        '
        Me.LoadWorker.WorkerReportsProgress = True
        '
        'HotSpotWorker
        '
        Me.HotSpotWorker.WorkerReportsProgress = True
        Me.HotSpotWorker.WorkerSupportsCancellation = True
        '
        'DataGridView
        '
        Me.DataGridView.AllowUserToAddRows = False
        Me.DataGridView.AllowUserToDeleteRows = False
        Me.DataGridView.AllowUserToOrderColumns = True
        Me.DataGridView.AutoSizeRowsMode = System.Windows.Forms.DataGridViewAutoSizeRowsMode.AllCells
        Me.DataGridView.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize
        Me.DataGridView.ColumnHeadersVisible = False
        Me.DataGridView.Columns.AddRange(New System.Windows.Forms.DataGridViewColumn() {Me.DataName, Me.DataValue})
        Me.DataGridView.Location = New System.Drawing.Point(471, 31)
        Me.DataGridView.Name = "DataGridView"
        Me.DataGridView.ReadOnly = True
        Me.DataGridView.RowHeadersWidth = 10
        Me.DataGridView.RowHeadersWidthSizeMode = System.Windows.Forms.DataGridViewRowHeadersWidthSizeMode.DisableResizing
        Me.DataGridView.SelectionMode = System.Windows.Forms.DataGridViewSelectionMode.CellSelect
        Me.DataGridView.Size = New System.Drawing.Size(200, 130)
        Me.DataGridView.TabIndex = 4
        Me.DataGridView.Visible = False
        '
        'DataName
        '
        Me.DataName.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.AllCells
        Me.DataName.HeaderText = "Name"
        Me.DataName.MaxInputLength = 20
        Me.DataName.Name = "DataName"
        Me.DataName.ReadOnly = True
        Me.DataName.Width = 5
        '
        'DataValue
        '
        Me.DataValue.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.Fill
        Me.DataValue.HeaderText = "Value"
        Me.DataValue.MaxInputLength = 20
        Me.DataValue.Name = "DataValue"
        Me.DataValue.ReadOnly = True
        '
        'frmMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(784, 738)
        Me.Controls.Add(Me.DataGridView)
        Me.Controls.Add(Me.ctrlTabs)
        Me.Controls.Add(Me.StatusBar)
        Me.Controls.Add(Me.MenuStrip)
        Me.Controls.Add(Me.PictureBox)
        Me.Cursor = System.Windows.Forms.Cursors.Default
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MinimumSize = New System.Drawing.Size(750, 750)
        Me.Name = "frmMain"
        Me.Text = "3D Model Viewer - eFatigue.com"
        Me.WindowState = System.Windows.Forms.FormWindowState.Maximized
        Me.StatusBar.ResumeLayout(False)
        Me.StatusBar.PerformLayout()
        Me.MenuStrip.ResumeLayout(False)
        Me.MenuStrip.PerformLayout()
        Me.ctrlTabs.ResumeLayout(False)
        Me.TabPage1.ResumeLayout(False)
        Me.TabPage1.PerformLayout()
        Me.pnlLegend.ResumeLayout(False)
        Me.pnlLegend.PerformLayout()
        CType(Me.picLegend, System.ComponentModel.ISupportInitialize).EndInit()
        Me.TabPage2.ResumeLayout(False)
        Me.TabPage2.PerformLayout()
        CType(Me.PictureBox, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.DataGridView, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

#Region " Main Window Controls"
    Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        InitializeConstants()   ' Load initial values for constants
        hDC = User.GetDC(PictureBox.Handle) ' set PictureBox as OpenGL destination
    End Sub

    Private Sub frmMain_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        CloseOut()      'Graceful exit from the program
    End Sub

    Private Sub frmMain_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        ' Arrange the main window
        PictureBox.Top = MenuStrip.Bottom
        PictureBox.Left = 0
        PictureBox.Width = ctrlTabs.Left - PictureBox.Left
        PictureBox.Height = StatusBar.Top - MenuStrip.Bottom

        ' Reset opengl window size parameters
        ReInit = True
    End Sub

    Private Sub mnuExit_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mnuExit.Click
        CloseOut()      'Graceful exit from the program
    End Sub

    Private Sub mnuOpen_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mnuOpen.Click
        ' stop animation if it is going on
        If AnimateWorker.IsBusy = True Then
            AnimateWorker.CancelAsync()
        End If

        ' Open the file dialog to get the filename to load
        Dim F2 As New System.Windows.Forms.OpenFileDialog
        F2.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*"
        F2.ShowDialog()

        If F2.FileName <> "" Then
            strFileName = F2.FileName

            Me.Cursor = Cursors.WaitCursor

            StatusLabel.Text = "Loading Model ..."

            ' clear the hotspot
            DataGridView.Visible = False
            SelectedHotSpot = Nothing

            ' Load the file in the background
            LoadWorker.RunWorkerAsync(strFileName)
        End If
    End Sub

    Private Sub mnuAbout_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mnuAbout.Click
        Dim F2 As New AboutBox()
        F2.ShowDialog()
        F2.Dispose()
    End Sub

    Private Sub mnuSaveAs_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mnuSaveAs.Click
        ' get some statistics about the screen size
        Dim BorderWidth As Integer = (Me.Width - Me.ClientSize.Width) / 2
        Dim TitlebarHeight As Integer = Me.Height - Me.ClientSize.Height - BorderWidth

        ' take a screenshot of just the picturebox where the model is
        Dim b As Bitmap
        b = New Bitmap(PictureBox.Width, PictureBox.Height)
        Dim g As Graphics = Graphics.FromImage(b)
        g.CopyFromScreen(PictureBox.Location + Me.DesktopLocation + New Point(BorderWidth, TitlebarHeight), New Point(0, 0), b.Size)

        ' Open the save as dialog box and get the filename to save to
        Dim saveFileDialog1 As New SaveFileDialog()
        saveFileDialog1.Filter = "JPEG Image|*.jpg|Bitmap Image|*.bmp|Gif Image|*.gif|Tiff Image|*.tiff"
        saveFileDialog1.Title = "Save the Image to a File"
        saveFileDialog1.ShowDialog()

        ' Save the file
        If saveFileDialog1.FileName <> "" Then
            Select Case saveFileDialog1.FileName.Substring(saveFileDialog1.FileName.LastIndexOf(".") + 1).ToLower
                Case "bmp"
                    b.Save(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Bmp)
                Case "jpg", "jpeg"
                    b.Save(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Jpeg)
                Case "gif"
                    b.Save(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Gif)
                Case "tif", "tiff"
                    b.Save(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Tiff)
            End Select
        End If

        saveFileDialog1.Dispose()

        'MsgBox("File Saved.", MsgBoxStyle.OkOnly + MsgBoxStyle.Information, "File Saved")
    End Sub

    Private Sub VisitUsOnTheWebToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VisitUsOnTheWebToolStripMenuItem.Click
        System.Diagnostics.Process.Start("https://www.efatigue.com/fem/3D_viewer.html")
    End Sub

    Private Sub mnuOptions_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mnuOptions.Click
        ' Open the Settings Form and record the results
        Dim frmSettings As New SettingsForm

        ' assign current values as initial values on the form
        frmSettings.PlotGrid = Plot_Grid
        frmSettings.RPM = RPMs
        frmSettings.LightIntensity = Light_Param
        frmSettings.PlotModel = Plot_Model
        frmSettings.HotSpotMin = HotSpotMin
        frmSettings.HotSpotSensitivity = HotSpotSensitivity
        frmSettings.HotSpotRadius = HotSpotRadius

        ' show the form
        frmSettings.ShowDialog()

        ' update settings
        If frmSettings.UpdateSettings Then
            Plot_Grid = frmSettings.PlotGrid
            RPMs = frmSettings.RPM
            Light_Param = frmSettings.LightIntensity

            BkgColor.R = frmSettings.BkgColor.R / 255
            BkgColor.G = frmSettings.BkgColor.G / 255
            BkgColor.B = frmSettings.BkgColor.B / 255

            Plot_Model = frmSettings.PlotModel

            HotSpotMin = frmSettings.HotSpotMin
            HotSpotSensitivity = frmSettings.HotSpotSensitivity
            HotSpotRadius = frmSettings.HotSpotRadius

            ' reinitialize OpenGl to begin displaying changes
            ReInit = True
        End If

        frmSettings.Dispose()
    End Sub

    Private Sub mnuLoadSample_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mnuLoadSample.Click
        ' stop animation if it is going on
        If AnimateWorker.IsBusy = True Then
            AnimateWorker.CancelAsync()
        End If

        strFileName = "eFatigue Viewer data.txt"

        Me.Cursor = Cursors.WaitCursor

        StatusLabel.Text = "Loading Model ..."

        ' Load the file in the background
        LoadWorker.RunWorkerAsync(strFileName)
    End Sub
#End Region

#Region "Model Controls"
    Private Sub txtZoom_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtZoom.KeyPress
        ' Update the zoom factor if user presses Enter on the text box
        If e.KeyChar = vbCr Then
            Zoom = refZoom * 100 / txtZoom.Text
            ReInit = True
            txtZoom.SelectAll()
        End If
    End Sub

    Private Sub cmdRotDown_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdRotDown.Click
        RotUp = RotUp + RPMs
    End Sub

    Private Sub cmdRotUp_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdRotUp.Click
        RotUp = RotUp - RPMs
    End Sub

    Private Sub cmdRotRight_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdRotRight.Click
        RotRight = RotRight + RPMs
    End Sub

    Private Sub cmdRotLeft_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdRotLeft.Click
        RotRight = RotRight - RPMs
    End Sub

    Private Sub cmdRotStop_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdRotStop.Click
        RotRight = 0
        RotUp = 0
    End Sub

    Private Sub cmdMovLeft_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdMovLeft.Click
        XShift = XShift - 0.05 * Zoom
    End Sub

    Private Sub cmdMovRight_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdMovRight.Click
        XShift = XShift + 0.05 * Zoom
    End Sub

    Private Sub cmdMovUp_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdMovUp.Click
        YShift = YShift + 0.05 * Zoom
    End Sub

    Private Sub cmdMovDown_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdMovDown.Click
        YShift = YShift - 0.05 * Zoom
    End Sub

    Private Sub cmdMovCenter_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdMovCenter.Click
        XShift = 0
        YShift = 0
    End Sub

    Private Sub cmdResetRotation_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdResetRotation.Click
        cmdRotStop_Click(sender, e)
        arrAdjPoints = arrPoints
        arrAdjNormals = arrNormals

    End Sub

    Private Sub cmbPlotType_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmbPlotType.SelectedIndexChanged
        Dim result As Integer
        result = ReadIntensity(strFileName, cmbPlotType.Text, UBound(arrPoints, 1))

        If cmbPlotType.Text <> "None" Then
            intensityMaxMin = FindMaxMin(arrIntensity)
            arrAdjIntensity = Normalize(arrIntensity, intensityMaxMin)             ' normalize intensity values
            'EnableCriticalPoints()
        Else
            arrAdjIntensity = arrIntensity
            intensityMaxMin(0) = 0
            intensityMaxMin(1) = 0
        End If

        DisableCriticalPoints()
        UpdateLegend()
        UpdateColorMode(cmbPlotType.Text)
    End Sub

    Private Sub txtLegend_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtLegendMax.KeyDown, txtLegendMin.KeyDown
        If e.KeyCode = Keys.Escape Then
            UpdateLegend()
        End If
    End Sub

    Private Sub txtLegendMax_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtLegendMax.KeyPress
        If e.KeyChar = vbCr Then
            MaxMin_Change()
            txtLegendMax.SelectAll()
        End If
    End Sub

    Private Sub txtLegendMin_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtLegendMin.KeyPress
        If e.KeyChar = vbCr Then
            MaxMin_Change()
            txtLegendMin.SelectAll()
        End If
    End Sub

    Private Sub txtLegend_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtLegendMax.LostFocus, txtLegendMin.LostFocus
        MaxMin_Change()
    End Sub

    Private Sub radMin_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles radMin.CheckedChanged
        ColorMode = 1
        UpdateLegend()
    End Sub

    Private Sub radMax_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles radMax.CheckedChanged
        ColorMode = 0
        UpdateLegend()
    End Sub
#End Region

#Region "Hot Spot Controls"
    Private Sub cmdViewChange_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdViewChange.Click
        ' stop rotation and recenter the object
        cmdRotStop_Click(sender, e)
        cmdMovCenter_Click(sender, e)
        Zoom = refZoom
        txtZoom.Text = 100

        SelectedHotSpot = HotSpots(cmbCriticalPoints.Text - 1)

        ' Determine the angle to rotate around the y-axis
        Dim Vec() As Single = {arrNormals(SelectedHotSpot, 0), arrNormals(SelectedHotSpot, 1), arrNormals(SelectedHotSpot, 2)}
        Dim Theta(2) As Single
        Theta = ManualRotateToVector(Vec)

        ' rotate the model
        arrAdjPoints = ManualRotateY(Theta(1), arrPoints)
        arrAdjNormals = ManualRotateY(Theta(1), arrNormals)
        arrAdjPoints = ManualRotateX(Theta(0), arrAdjPoints)
        arrAdjNormals = ManualRotateX(Theta(0), arrAdjNormals)

        ' Find node properties
        Dim i As Integer
        For i = 0 To UBound(HotSpotParameters, 1)
            If HotSpotParameters(i, 0) = SelectedHotSpot Then
                Exit For
            End If
        Next

        ' Display Node Properties
        Dim j As Integer
        DataGridView.Rows.Clear()
        For j = 1 To UBound(HotSpotParameters, 2)
            DataGridView.Rows.Add()
            DataGridView.Rows(j - 1).Cells(0).Value = arrModes(j)
            If InStr(LCase(arrModes(j)), "log") Then
                DataGridView.Rows(j - 1).Cells(1).Value = Round(10 ^ HotSpotParameters(i, j), 0)
            Else
                DataGridView.Rows(j - 1).Cells(1).Value = HotSpotParameters(i, j)
            End If
        Next
        DataGridView.Top = PictureBox.Top + 3
        DataGridView.Left = PictureBox.Right - 3 - DataGridView.Width
        DataGridView.Visible = True

        cmdClear.Enabled = True
    End Sub

    Private Sub cmdRefreshHotSpot_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdRefreshHotSpot.Click
        If HotSpotWorker.IsBusy Then
            HotSpotWorker.CancelAsync()
        Else
            Me.Cursor = Cursors.WaitCursor
            cmdRefreshHotSpot.Cursor = Cursors.Arrow
            ProgressBar.Value = 0
            cmdRefreshHotSpot.Text = "Cancel"
            cmbCriticalPoints.Items.Clear()
            StatusLabel.Text = "Analyzing Hot Spots ..."
            HotSpotWorker.RunWorkerAsync()
        End If

    End Sub

    Private Sub cmdClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClear.Click
        DataGridView.Visible = False
        SelectedHotSpot = Nothing
    End Sub
#End Region


#Region " Support Functions "
    Private Sub CloseOut()
        ' Graceful exit from application
        ' Cancel the OpenGL background process
        AnimateWorker.CancelAsync()
        End
    End Sub

    Private Sub InitializeConstants()
        ' Set animation constants to their initial values
        ' always start with no rotation and a centered model
        RotUp = 0
        RotRight = 0
        XShift = 0
        YShift = 0
        Plot_Model = True
        ColorMode = 0

        ' load other settings from memory
        RPMs = My.Settings.RPMs
        Plot_Grid = My.Settings.Plot_Grid
        Light_Param = My.Settings.Light_Param
        BkgColor.R = My.Settings.BkgColor_R
        BkgColor.G = My.Settings.BkgColor_G
        BkgColor.B = My.Settings.BkgColor_B
        HotSpotMin = My.Settings.HotSpotMin
        HotSpotSensitivity = My.Settings.HotSpotSensitivity
        HotSpotRadius = My.Settings.HotSpotRadius
    End Sub

    Private Sub EnableCriticalPoints()
        cmdViewChange.Enabled = True
        cmbCriticalPoints.Enabled = True
        cmbCriticalPoints.SelectedIndex = 0
    End Sub

    Private Sub DisableCriticalPoints()
        cmdViewChange.Enabled = False
        cmdClear.Enabled = False
        cmbCriticalPoints.Enabled = False
        cmbCriticalPoints.Items.Clear()
    End Sub

    Private Sub PopulatePlotMode(ByVal arrModes() As String)
        Dim i As Integer
        cmbPlotType.Items.Clear()
        For i = 0 To UBound(arrModes)
            cmbPlotType.Items.Add(arrModes(i))
        Next

        cmbPlotType.SelectedIndex = 0
    End Sub

    Private Sub UpdateLegend()
        If ColorMode = 1 Then
            txtLegendMin.Text = Round(intensityMaxMin(1), 3)
            txtLegendMax.Text = Round(intensityMaxMin(0), 3)
        Else
            txtLegendMax.Text = Round(intensityMaxMin(1), 3)
            txtLegendMin.Text = Round(intensityMaxMin(0), 3)
        End If

        If txtLegendMax.Text > 0 Or txtLegendMin.Text > 0 Then
            pnlLegend.Visible = True
        Else
            pnlLegend.Visible = False
        End If

    End Sub

    Private Sub UpdateColorMode(ByVal PlotType As String)
        If InStr(LCase(PlotType), "nf") Or InStr(LCase(PlotType), "safety") Then
            ColorMode = 1
            radMin.Checked = True
        Else
            ColorMode = 0
            radMax.Checked = True
        End If
    End Sub

    Private Sub MaxMin_Change()
        Dim result As Int16

        result = ValidateData(txtLegendMax.Text)
        If result <> 1 Then
            MsgBox("Illegal Character Found in Maximum Value Entry.", MsgBoxStyle.Critical + MsgBoxStyle.OkOnly, "Error")
        Else
            result = ValidateData(txtLegendMin.Text)
            If result <> 1 Then
                MsgBox("Illegal Character Found in Minimum Value Entry.", MsgBoxStyle.Critical + MsgBoxStyle.OkOnly, "Error")
            Else

                If CDbl(txtLegendMax.Text) <= CDbl(txtLegendMin.Text) Then
                    MsgBox("Maximum Value less than or equal to Minimum Value.", MsgBoxStyle.Critical + MsgBoxStyle.OkOnly, "Error")
                Else
                    intensityMaxMin(0) = txtLegendMax.Text
                    intensityMaxMin(1) = txtLegendMin.Text

                    arrAdjIntensity = Normalize(arrIntensity, intensityMaxMin)
                End If
            End If
        End If

    End Sub

    Private Sub AnimateWorker_DoWork(ByVal sender As Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles AnimateWorker.DoWork
        Dim Now As DateTime
        Dim LastScan As DateTime
        Dim diff As Integer
        Dim RotUp_Angle As Double
        Dim RotRight_Angle As Double
        'ReDim arrAdjPoints(UBound(arrPoints, 1), 2)

        ' initialize the time stamp
        Now = DateTime.Now

        EnableOpenGL(e.Argument)                   ' Enable OpenGL
        ReInit = True                               ' Be sure to initialize at least once

        ' Continue rendering until the process is cancelled
        While Not AnimateWorker.CancellationPending
            ' update timestamp and calculate elapsed time
            LastScan = Now
            Now = DateTime.Now
            diff = Now.Subtract(LastScan).Milliseconds

            RotUp_Angle = PI * RotUp * diff / 30000         ' convert rotation (in rpm) to radians
            RotRight_Angle = PI * RotRight * diff / 30000   ' convert rotation (in rpm) to radians

            ' manually rotate the points by the given amount
            arrAdjPoints = ManualRotateX(RotUp_Angle, arrAdjPoints)
            arrAdjNormals = ManualRotateX(RotUp_Angle, arrAdjNormals)
            arrAdjPoints = ManualRotateY(RotRight_Angle, arrAdjPoints)
            arrAdjNormals = ManualRotateY(RotRight_Angle, arrAdjNormals)

            ' reinitialize OpenGl when requested
            If ReInit Then
                InitializeOpenGL(PictureBox.Width, PictureBox.Height, Zoom, Light_Param, BkgColor)
                ReInit = False
            End If

            ' call opengl to draw the scene
            DrawScene(hDC, arrAdjPoints, arrCells, arrAdjIntensity, arrAdjNormals, Zoom, XShift, YShift, Plot_Grid, Plot_Model, SelectedHotSpot, HotSpotRadius * refZoom, ColorMode)

            'lblDebug.Text = "Frames Per Second = " & Round(1000 / diff, 2)
        End While

        ' disable OpenGl when drawing is finished
        DisableOpenGL()
    End Sub

    Private Sub LoadWorker_DoWork(ByVal sender As Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles LoadWorker.DoWork
        Dim result As Int16

        ' Load the file
        result = ReadFile(e.Argument.ToString, LoadWorker, 5)

        ' if the file was read sucessfully, start displaying model
        If result = 1 Then
            ' get the intensity values
            result = ReadIntensity(e.Argument.ToString, "None", UBound(arrPoints, 1))
            arrAdjIntensity = arrIntensity

            ' if the intensity read succeded, draw the model
            If result = 1 Then
                arrModes = ReadModes(strFileName)   ' Read the file to get the available plot modes
                e.Result = arrModes

                InitializeConstants()               ' Set animation constants to their initial values
                CenterModel(arrPoints)              ' center the model on the origin

                CalNormals(arrPoints, arrCells, arrNormals, LoadWorker, 5) ' calculate the normals
                refZoom = SetZoom(arrPoints)                ' Determine the initial zoom
                Zoom = refZoom

                ' make sure there are some points in the Adj arrays
                ReDim arrAdjPoints(UBound(arrPoints, 1), 2)
                ReDim arrAdjNormals(UBound(arrNormals, 1), 2)
                arrAdjPoints = arrPoints
                arrAdjNormals = arrNormals

                ' reinitialize OpenGL and start the background worker (if it is not already started.)
                ReInit = True
                If AnimateWorker.IsBusy = False Then
                    AnimateWorker.RunWorkerAsync(hDC)
                End If
            End If
        End If
    End Sub

    Private Sub LoadWorker_ProgressChanged(ByVal sender As Object, ByVal e As System.ComponentModel.ProgressChangedEventArgs) Handles LoadWorker.ProgressChanged
        ' reset the progressbar if it is full
        If ProgressBar.Value >= ProgressBar.Maximum Then
            ProgressBar.Value = ProgressBar.Minimum
        End If

        ProgressBar.Increment(e.ProgressPercentage)
    End Sub

    Private Sub LoadWorker_RunWorkerCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles LoadWorker.RunWorkerCompleted
        ' Update screen controls after file load is complete

        ' be sure the progressbar is maxed out (just in case it is only 99% full)
        ProgressBar.Value = ProgressBar.Maximum

        ' Mode List
        PopulatePlotMode(e.Result)

        ' Zoom Level
        txtZoom.Text = "100"

        ' Save As Enable
        mnuSaveAs.Enabled = True

        ' Hotspot Enable
        cmdRefreshHotSpot.Enabled = True

        ' update the screen to show the current file being plotted
        UpdateFileName()

        ' Cursor
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub UpdateFileName()
        If Len(strFileName) > 30 Then
            StatusLabel.Text = "..." + Microsoft.VisualBasic.Strings.Right(strFileName, 30)
        Else
            StatusLabel.Text = strFileName
        End If
    End Sub

    Private Sub HotSpotWorker_DoWork(ByVal sender As Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles HotSpotWorker.DoWork
        HotSpots = FindHotSpots(HotSpotWorker, HotSpotMin, HotSpotSensitivity, ColorMode)

        If HotSpotWorker.CancellationPending Then
            e.Cancel = True
        End If
    End Sub

    Private Sub HotSpotWorker_RunWorkerCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles HotSpotWorker.RunWorkerCompleted

        If e.Cancelled Then
            MsgBox("Hot Spot Analysis Cancelled.", MsgBoxStyle.Information + MsgBoxStyle.OkOnly, "Cancelled")
        Else
            If UBound(HotSpots) >= 0 Then
                Dim i As Integer
                For i = 0 To UBound(HotSpots)
                    cmbCriticalPoints.Items.Add(i + 1)
                Next i
                EnableCriticalPoints()

                ReDim HotSpotParameters(UBound(HotSpots), cmbPlotType.Items.Count - 1)
                For i = 0 To UBound(HotSpots)
                    HotSpotParameters(i, 0) = HotSpots(i)
                Next i

                HotSpotParameters = BubbleSort(HotSpotParameters, 0)        ' put the nodes in numerical order
                SeekNodeValues(strFileName, arrModes, HotSpotParameters)
            Else
                MsgBox("No critical points found.", MsgBoxStyle.Information + MsgBoxStyle.OkOnly, "None Found")
            End If
        End If

        cmdRefreshHotSpot.Text = "Analyze"
        cmdRefreshHotSpot.Cursor = Cursors.Default
        UpdateFileName()
        ProgressBar.Value = ProgressBar.Maximum
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub HotSpotWorker_ProgressChanged(ByVal sender As Object, ByVal e As System.ComponentModel.ProgressChangedEventArgs) Handles HotSpotWorker.ProgressChanged
        StatusLabel.Text = "Analyzing Hot Spots ... " + CStr(e.UserState + 1) + " found."
        ProgressBar.Increment(e.ProgressPercentage * ProgressBar.Maximum - ProgressBar.Value)
    End Sub

#End Region
End Class
