Imports System.Math

Module Math_Functions

    ' Returns the cross product of the two input vectors.
    Function Cross_Product(ByVal Vec1 As Object, ByVal Vec2 As Object) As Object
        ' TempArray is a temporary variable to store the cross product.
        Dim TempArray(2) As Single

        ' The following lines put elements of the product into TempArray.
        TempArray(0) = Vec1(1) * Vec2(2) - Vec1(2) * Vec2(1)
        TempArray(1) = Vec1(2) * Vec2(0) - Vec1(0) * Vec2(2)
        TempArray(2) = Vec1(0) * Vec2(1) - Vec1(1) * Vec2(0)

        Cross_Product = TempArray

    End Function

    ' determine length of a vector
    Function Vector_Length(ByVal Vec As Object) As Object
        Dim sum As Double
        Dim i As Integer

        sum = 0
        For i = LBound(Vec) To UBound(Vec)
            sum += Vec(i) ^ 2
        Next

        Vector_Length = sum ^ 0.5
    End Function

    ' add 2 vectors
    Function Vector_Add(ByVal Vec1 As Object, ByVal Vec2 As Object) As Object
        Dim TempArray(2) As Single

        TempArray(0) = Vec1(0) + Vec2(0)
        TempArray(1) = Vec1(1) + Vec2(1)
        TempArray(2) = Vec1(2) + Vec2(2)

        Vector_Add = TempArray
    End Function

    ' subtract 2 vectors
    Function Vector_Subtract(ByVal Vec1 As Object, ByVal Vec2 As Object) As Object
        Dim TempArray(2) As Single

        TempArray(0) = Vec1(0) - Vec2(0)
        TempArray(1) = Vec1(1) - Vec2(1)
        TempArray(2) = Vec1(2) - Vec2(2)

        Vector_Subtract = TempArray
    End Function

    Function Vector_Unit(ByVal Vec1 As Object) As Object
        Dim len As Single
        Dim i As Int16

        len = Vector_Length(Vec1)
        For i = 0 To UBound(Vec1)
            Vec1(i) = Vec1(i) / len
        Next

        Vector_Unit = Vec1
    End Function

    Function ManualRotateX(ByVal Theta As Single, ByRef arrPoints(,) As Single) As Single(,)
        If Theta <> 0 Then
            Dim arrAdjPoints(0, 2) As Single
            ReDim arrAdjPoints(UBound(arrPoints, 1), 2)
            Dim cosTheta As Double
            Dim sinTheta As Double

            cosTheta = Cos(Theta)
            sinTheta = Sin(Theta)

            Dim i As Integer

            For i = 0 To UBound(arrPoints, 1)
                arrAdjPoints(i, 0) = arrPoints(i, 0)
                arrAdjPoints(i, 1) = arrPoints(i, 1) * cosTheta - arrPoints(i, 2) * sinTheta
                arrAdjPoints(i, 2) = arrPoints(i, 1) * sinTheta + arrPoints(i, 2) * cosTheta

            Next

            ManualRotateX = arrAdjPoints
        Else
            ManualRotateX = arrPoints
        End If
    End Function

    Function ManualRotateX(ByVal Theta As Single, ByRef arrPoint() As Single) As Single()
        If Theta <> 0 Then
            Dim arrAdjPoint(2) As Single
            Dim cosTheta As Double
            Dim sinTheta As Double

            cosTheta = Cos(Theta)
            sinTheta = Sin(Theta)

            arrAdjPoint(0) = arrPoint(0)
            arrAdjPoint(1) = arrPoint(1) * cosTheta - arrPoint(2) * sinTheta
            arrAdjPoint(2) = arrPoint(1) * sinTheta + arrPoint(2) * cosTheta

            ManualRotateX = arrAdjPoint
        Else
            ManualRotateX = arrPoint
        End If
    End Function

    Function ManualRotateY(ByVal Theta As Single, ByRef arrPoints(,) As Single) As Single(,)
        If Theta <> 0 Then
            Dim arrAdjPoints(0, 2) As Single
            ReDim arrAdjPoints(UBound(arrPoints, 1), 2)
            Dim cosTheta As Double
            Dim sinTheta As Double

            cosTheta = Cos(Theta)
            sinTheta = Sin(Theta)

            Dim i As Integer

            For i = 0 To UBound(arrPoints, 1)
                arrAdjPoints(i, 0) = arrPoints(i, 0) * cosTheta + arrPoints(i, 2) * sinTheta
                arrAdjPoints(i, 1) = arrPoints(i, 1)
                arrAdjPoints(i, 2) = -arrPoints(i, 0) * sinTheta + arrPoints(i, 2) * cosTheta
            Next

            ManualRotateY = arrAdjPoints
        Else
            ManualRotateY = arrPoints
        End If
    End Function

    Function ManualRotateY(ByVal Theta As Single, ByRef arrPoint() As Single) As Single()
        If Theta <> 0 Then
            Dim arrAdjPoint(2) As Single
            Dim cosTheta As Double
            Dim sinTheta As Double

            cosTheta = Cos(Theta)
            sinTheta = Sin(Theta)

            arrAdjPoint(0) = arrPoint(0) * cosTheta + arrPoint(2) * sinTheta
            arrAdjPoint(1) = arrPoint(1)
            arrAdjPoint(2) = -arrPoint(0) * sinTheta + arrPoint(2) * cosTheta

            ManualRotateY = arrAdjPoint
        Else
            ManualRotateY = arrPoint
        End If
    End Function

    Function ManualRotateZ(ByVal Theta As Single, ByRef arrPoints(,) As Single) As Single(,)
        If Theta <> 0 Then
            Dim arrAdjPoints(0, 2) As Single
            ReDim arrAdjPoints(UBound(arrPoints, 1), 2)
            Dim cosTheta As Double
            Dim sinTheta As Double

            cosTheta = Cos(Theta)
            sinTheta = Sin(Theta)

            Dim i As Integer

            For i = 0 To UBound(arrPoints, 1)
                arrAdjPoints(i, 0) = arrPoints(i, 0) * cosTheta + arrPoints(i, 1) * sinTheta
                arrAdjPoints(i, 1) = -arrPoints(i, 0) * sinTheta + arrPoints(i, 1) * cosTheta
                arrAdjPoints(i, 2) = arrPoints(i, 2)
            Next

            ManualRotateZ = arrAdjPoints
        Else
            ManualRotateZ = arrPoints
        End If
    End Function

    Function ManualRotateZ(ByVal Theta As Single, ByRef arrPoint() As Single) As Single()
        If Theta <> 0 Then
            Dim arrAdjPoint(2) As Single
            Dim cosTheta As Double
            Dim sinTheta As Double

            cosTheta = Cos(Theta)
            sinTheta = Sin(Theta)

            arrAdjPoint(0) = arrPoint(0) * cosTheta + arrPoint(1) * sinTheta
            arrAdjPoint(1) = -arrPoint(0) * sinTheta + arrPoint(1) * cosTheta
            arrAdjPoint(2) = arrPoint(2)

            ManualRotateZ = arrAdjPoint
        Else
            ManualRotateZ = arrPoint
        End If
    End Function

    Function ManualRotateToVector(ByVal Vec() As Single) As Single()
        Dim Result(2) As Single
        Dim RotVector(2) As Single

        ' z-axis rotation is zero
        Result(2) = 0

        ' Determine the angle to rotate around the y-axis

        ' Take the normal of that point
        RotVector(0) = Vec(0)
        RotVector(1) = Vec(2)
        RotVector = Vector_Unit(RotVector) ' make 2D unit vector

        If RotVector(1) <= 0 Then
            Result(1) = Math.PI / 2 - Acos(RotVector(0))
        ElseIf RotVector(1) > 0 Then
            Result(1) = Math.PI / 2 + Acos(RotVector(0))
        End If

        ' rotate the model
        Vec = ManualRotateY(Result(1), Vec)


        ' Determine the angle to rotate around the x-axis

        ' Take the normal of that point
        RotVector(0) = Vec(1)
        RotVector(1) = Vec(2)
        RotVector = Vector_Unit(RotVector) ' make 2D unit vector

        If RotVector(0) <= 0 Then
            Result(0) = Math.PI - Acos(RotVector(1))
        ElseIf RotVector(0) > 0 Then
            Result(0) = Acos(RotVector(1)) - Math.PI
        End If

        ManualRotateToVector = Result
    End Function
End Module
