Public Class SettingsForm
    Dim mBkgColor As Color = Color.Black
    Dim mUpdate As Boolean = False

    Public Property PlotGrid() As Boolean
        Get
            Return chkGrid.Checked
        End Get
        Set(ByVal value As Boolean)
            chkGrid.Checked = value
        End Set
    End Property

    Public Property PlotModel() As Boolean
        Get
            Return chkModel.Checked
        End Get
        Set(ByVal value As Boolean)
            chkModel.Checked = value
        End Set
    End Property

    Public Property RPM() As Single
        Get
            Return trkbarSpeed.Value
        End Get
        Set(ByVal value As Single)
            trkbarSpeed.Value = value
        End Set
    End Property

    Public Property LightIntensity() As Single
        Get
            Return trkbarIntensity.Value / trkbarIntensity.Maximum
        End Get
        Set(ByVal value As Single)
            trkbarIntensity.Value = value * trkbarIntensity.Maximum
        End Set
    End Property

    Public Property BkgColor() As Color
        Get
            Return mBkgColor
        End Get
        Set(ByVal value As Color)
            mBkgColor = value
        End Set
    End Property

    Public Property HotSpotMin() As Single
        Get
            Return txtHotSpotMin.Text / 100
        End Get
        Set(ByVal value As Single)
            txtHotSpotMin.Text = value * 100
        End Set
    End Property

    Public Property HotSpotSensitivity() As Single
        Get
            Return txtHotSpotSensitivity.Text / 100
        End Get
        Set(ByVal value As Single)
            txtHotSpotSensitivity.Text = value * 100
        End Set
    End Property

    Public Property HotSpotRadius() As Single
        Get
            Return txtHotSpotradius.Text / 100
        End Get
        Set(ByVal value As Single)
            txtHotSpotradius.Text = value * 100
        End Set
    End Property


    Public ReadOnly Property UpdateSettings() As Boolean
        Get
            Return mUpdate
        End Get
    End Property


    Private Sub cmdSave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdSave.Click
        My.Settings.RPMs = trkbarSpeed.Value
        My.Settings.Plot_Grid = chkGrid.Checked
        My.Settings.Light_Param = trkbarIntensity.Value / trkbarIntensity.Maximum
        My.Settings.BkgColor_R = mBkgColor.R
        My.Settings.BkgColor_G = mBkgColor.G
        My.Settings.BkgColor_B = mBkgColor.B
        My.Settings.HotSpotMin = txtHotSpotMin.Text / 100
        My.Settings.HotSpotSensitivity = txtHotSpotSensitivity.Text / 100
        My.Settings.HotSpotRadius = txtHotSpotRadius.Text / 100

        My.Settings.Save()
        MsgBox("Settings Saved.", MsgBoxStyle.OkOnly + MsgBoxStyle.Information, "Saved")
    End Sub


    Private Sub cmdOk_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdOk.Click
        mUpdate = True
        Me.Close()
    End Sub

    Private Sub cmdCancel_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdCancel.Click
        Me.Close()
    End Sub

    Private Sub cmdBkColor_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdBkColor.Click
        ' Open the color selector dialog
        Dim C2 As New System.Windows.Forms.ColorDialog
        C2.Color = mBkgColor
        C2.ShowDialog()

        mBkgColor = C2.Color

        C2.Dispose()
    End Sub

    Dim NonNumberEntered As Boolean = True

    Private Sub txtHotSpot_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtHotSpotMin.KeyDown, txtHotSpotSensitivity.KeyDown, txtHotSpotRadius.KeyDown
        ' Initialize the flag to false.
        NonNumberEntered = False

        ' Determine whether the keystroke is a number from the top of the keyboard.
        If e.KeyCode < Keys.D0 OrElse e.KeyCode > Keys.D9 Then
            ' Determine whether the keystroke is a number from the keypad.
            If e.KeyCode < Keys.NumPad0 OrElse e.KeyCode > Keys.NumPad9 Then
                ' Determine whether the keystroke is a backspace.
                If e.KeyCode <> Keys.Back And e.KeyCode <> Keys.Decimal Then
                    ' A non-numerical keystroke was pressed. 
                    ' Set the flag to true and evaluate in KeyPress event.
                    NonNumberEntered = True
                End If
            End If
        End If
    End Sub


    Private Sub txtHotSpot_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtHotSpotMin.KeyPress, txtHotSpotSensitivity.KeyPress, txtHotSpotRadius.KeyPress
        If NonNumberEntered Then
            e.Handled = True
        End If

    End Sub

    Private Sub txtHotSpot_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtHotSpotMin.KeyUp, txtHotSpotSensitivity.KeyUp, txtHotSpotRadius.KeyUp
        If Microsoft.VisualBasic.Left(sender.text, 1) = "." Then
            sender.text = "0" & sender.text
            sender.SelectionStart = 2
        End If
        If sender.Text > 100 Or sender.Text <= 0 Then
            sender.BackColor = Color.Red
            sender.Font = New Font(Font, FontStyle.Bold)
            cmdOk.Enabled = False
            cmdSave.Enabled = False
        Else
            sender.BackColor = Color.White
            sender.Font = New Font(Font, FontStyle.Regular)
            cmdOk.Enabled = True
            cmdSave.Enabled = True
        End If
    End Sub

End Class